org.apache.http.message

## Interface LineFormatter

- All Known Implementing Classes:
    BasicLineFormatter

      public interface LineFormatter

  Interface for formatting elements of the HEAD section of an HTTP message. This is the complement to `LineParser`. There are individual methods for formatting a request line, a status line, or a header line. The formatting does not include the trailing line break sequence CR-LF. Instances of this interface are expected to be stateless and thread-safe.

  The formatted lines are returned in memory, the formatter does not depend on any specific IO mechanism. In order to avoid unnecessary creation of temporary objects, a buffer can be passed as argument to all formatting methods. The implementation may or may not actually use that buffer for formatting. If it is used, the buffer will first be cleared by the `formatXXX` methods. The argument buffer can always be re-used after the call. The buffer returned as the result, if it is different from the argument buffer, MUST NOT be modified.

  Since:
    4.0

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `CharArrayBuffer` | `appendProtocolVersion(CharArrayBuffer buffer, ProtocolVersion version)` Formats a protocol version.
    `CharArrayBuffer` | `formatHeader(CharArrayBuffer buffer, Header header)` Formats a header.
    `CharArrayBuffer` | `formatRequestLine(CharArrayBuffer buffer, RequestLine reqline)` Formats a request line.
    `CharArrayBuffer` | `formatStatusLine(CharArrayBuffer buffer, StatusLine statline)` Formats a status line.

- - ### Method Detail

    - #### appendProtocolVersion

          CharArrayBuffer appendProtocolVersion(CharArrayBuffer buffer,
                                              ProtocolVersion version)

      Formats a protocol version. This method does not follow the general contract for `buffer` arguments. It does not clear the argument buffer, but appends instead. The returned buffer can always be modified by the caller. Because of these differing conventions, it is not named `formatProtocolVersion`.
      Parameters:
        `buffer` - a buffer to which to append, or `null`
        `version` - the protocol version to format
      Returns:
        a buffer with the formatted protocol version appended. The caller is allowed to modify the result buffer. If the `buffer` argument is not `null`, the returned buffer is the argument buffer.

    - #### formatRequestLine

          CharArrayBuffer formatRequestLine(CharArrayBuffer buffer,
                                          RequestLine reqline)

      Formats a request line.
      Parameters:
        `buffer` - a buffer available for formatting, or `null`. The buffer will be cleared before use.
        `reqline` - the request line to format
      Returns:
        the formatted request line

    - #### formatStatusLine

          CharArrayBuffer formatStatusLine(CharArrayBuffer buffer,
                                         StatusLine statline)

      Formats a status line.
      Parameters:
        `buffer` - a buffer available for formatting, or `null`. The buffer will be cleared before use.
        `statline` - the status line to format
      Returns:
        the formatted status line
      Throws:
        `ParseException` - in case of a parse error

    - #### formatHeader

          CharArrayBuffer formatHeader(CharArrayBuffer buffer,
                                     Header header)

      Formats a header. Due to header continuation, the result may be multiple lines. In order to generate well-formed HTTP, the lines in the result must be separated by the HTTP line break sequence CR-LF. There is no trailing CR-LF in the result.
      See the class comment for details about the buffer argument.
      Parameters:
        `buffer` - a buffer available for formatting, or `null`. The buffer will be cleared before use.
        `header` - the header to format
      Returns:
        a buffer holding the formatted header, never `null`. The returned buffer may be different from the argument buffer.
      Throws:
        `ParseException` - in case of a parse error

Copyright © 2005–2013 The Apache Software Foundation. All rights reserved.